;;#0FAF(4015)  Border.  .

;---------------------------------------
; TSConf examples
; (C) breeze/fishbone crew 2013
;---------------------------------------

        DEVICE ZXSPECTRUM128


 org $4000
basb:
 inchob "SD.!b"
base:
		org	#8000-3

VPage		equ	#01AF
VConfig		equ	#00AF

XOffsL		equ	#02AF
XOffsH		equ	#03AF

RAMPage3	equ	#13AF

startCode
 jp dointro
st:incbin "sined.bin"
dointro:
 ld sp,$5FE0

		LD	BC,VConfig    ;  : %01-320x200, %010-256 
		LD	A,%01000010
		;LD	A,%10000010
		OUT	(C),A
;-----------------------------------------
 ld ixl,200;y
 ld a,$20
		LD	BC,VPage      ;  ,     #20
		OUT	(C),A
drlp1:
		LD	BC,RAMPage3   ;   #20   #c000
		OUT	(C),A

		LD	HL,#c000
		LD	DE,#c001
		LD	BC,#3fff
		LD	(HL),L
		LDIR
		inc a
		cp $27:jr nz,drlp1;200/32=6
;------------mk palette
 ld e,0
palroll:
 ei:halt
 push de
;open FMAddr access from 0x0000
 ld bc, 0x15AF
 ld a, 0x10;0x18 - if $8000
 out (c), a

;load CRAM
 ld hl,$8000*0
 ld b,l
 ld c,l
pal:
;.: gggBBbbb
;.: 0RRrrrGG
 inc c
 ld a,c:cp 240+1
 ld a,0
 jr z,putv
 ld a,e
putv:
 and %11100000
 ld (hl),a:inc hl
 ld (hl),0:inc hl
nexte:
 inc e;:res 5,e
 djnz pal
 
;;  ld hl,0,($8000+240*2),hl

FMAddr     EQU #15AF
;close FMAddr
 ld bc, 0x15AF
 xor a
 out (c), a

 pop de
; inc e;:res 5,e
;
; jr nz,palroll
 
lutpl equ $6000;;bank, MSB addres=2*$100
 ld hl,lutpl
  push hl
  ld de,hl
  inc de
  ld (hl),0
  ld bc,511
  ldir
  pop hl
  ld de,$C020;bank #
lulp1:
 ld (hl),e;bank 
 inc h
 ld (hl),d
 dec h

 inc d,d
 ld a,d:or a
 jr nz,nonextbank
 ld d,$c0
 inc e
nonextbank:
 inc l
 ld a,l
 cp 200:jr nz,lulp1
;-----------------test plot
sdlp1:ei:halt
ab:ld bc,0;B=b,C=a
cd:ld de,0;D=c,E=d
  ld h,st/256
  xor a:ld (colm),a
  call drawdots

;  a01.a=$FC-3
;  b01.a=0
;  c01.a=4+3
;  d01.a=0
ab1:ld bc,$00FA;B=b,C=a
cd1:ld de,#0600;D=c,E=d
 ld a,$AF,(colm),a
 call drawdots

;a0=a0+1
;c0=c0-1
 ld hl,(ab+1)
 inc l
 ld (ab+1),hl
 
 ld hl,(cd+1)
 dec h
 ld (cd+1),hl
;
;a01=a01+1
;c01=c01-1
 ld hl,(ab1+1)
 inc l
 ld (ab1+1),hl
 
 ld hl,(cd1+1)
 dec h
 ld (cd1+1),hl

 ld iy,$5C3A
 jp sdlp1
drawdots:
  ld ixl,0;i
sdlp2:
;      x.b=S((a+64)&255)+s((b+64)&255);;+s(c)
;      y.b=s(c)+s(d)
;     Plot(x+240,y+240,65280)
;     a=a+1
;     b=b+3
;     c=c+1
;     d=d+2
 ld l,c
 ld a,(hl)
 ld l,b
 add a,(hl)
 ;;add a,$60
 ld iyl,a;x
 ld l,e
 ld a,(hl)
 ld l,d
 add a,(hl)
 add a,$60
 ld iyh,a;y
 
 push iy
 exx
 pop de;D=Y.X
 ld h,lutpl/256
 ld l,d;Y and bank
 ld a,(hl)
 or a:jr z,nextp
 inc h
 LD	BC,RAMPage3
 OUT	(C),A
 ld h,(hl)
 ld l,e;suppose X
 ld a,ixl
 ld de,$40:add hl,de
colm:nop
colr: ld (hl),a
nextp:
 exx
 inc c
 inc b,b
 inc e
 inc d,d,d
 inc ixl
 jp nz,sdlp2
 ret

endCode:;		nop
 display /d,endCode-startCode
;	SAVESNA "sinedots.sna", startCode
    EMPTYTRD "sd.trd"
    SAVETRD "sd.trd","sd.C",startCode,endCode-startCode
    SAVETRD "sd.trd","SD.B",basb,base-basb
